// SRListBox.cpp : implementation file
//
// Author:	Ranjan Banerji
//  
//
//
//
//
//

#include "stdafx.h"
#include <afxcoll.h>
#include <afxtempl.h>
#include "SRListBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// SRListBox

SRListBox::SRListBox() : CListBox() {
	_selectionArray.RemoveAll();
	_singleSelect = false;
}

SRListBox::SRListBox(const bool& single) : CListBox() {
	_selectionArray.RemoveAll();
	_singleSelect = single;
}

SRListBox::~SRListBox() {
	_selectionArray.RemoveAll();
}

bool SRListBox::Selection() const {
	bool retVal = false;

	if(_selectionArray.GetSize() > 0)
		retVal = true;

	return retVal;
}

BEGIN_MESSAGE_MAP(SRListBox, CListBox)
	//{{AFX_MSG_MAP(SRListBox)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// SRListBox message handlers

void SRListBox::UnSelectSelections(const int& except) {
//  Unselects all selected items except the except item
	int numberSelected = GetSelCount();

	if( numberSelected == LB_ERR ) { // Single Selection box
#if _DEBUG
		AfxMessageBox("Please set the ListBox Property to be multiple Select in the resource editor");
#endif
	}
	else { //multiple selection box
		int *selIndex = new int[numberSelected];

		GetSelItems( numberSelected, selIndex );
		for(int i=0;i<numberSelected;i++) {
			if( selIndex[i] != except )
				SetSel(selIndex[i], FALSE);
		}
		delete[] selIndex;
	}
}

void SRListBox::UpdateData(const BOOL& save) {
	if(_singleSelect) {
		int pos = GetCaretIndex();
		UnSelectSelections(pos);
	}
	if(save) {
		int numberSelected = GetSelCount();
		if(numberSelected>0) {
			int *selIndex = new int[numberSelected];
			int i=0;
			CString theText("");
			DWORD theItemData;

			_selectionArray.RemoveAll();
			int checkValue = GetSelItems( numberSelected, selIndex );
			if(checkValue == LB_ERR)
				AfxMessageBox("Nothing Selected. fn: SRListBox::UpdateData()");
			for(i=0;i<numberSelected;i++) {
				GetText(selIndex[i], theText);
				theItemData = GetItemData( selIndex[i] );
				SRCBAndLBItem* selection = new SRCBAndLBItem(selIndex[i], theText, theItemData);
				_selectionArray.Add(selection);
			}
			delete[] selIndex;
		}
	}
}